
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>模型评估与模型选择 / 憋错料</title>

    <meta name="description" content="模型评估与模型选择 机器学习算法 原理.实现与实战——模型评估与模型选择 1. 训练误差与测试误差 机器学习的目的是使学习到的模型不仅对已知数据而且对未知数据都能有很好的预测能力. 假设学习到的模型是$Y = \hat{f}(X)$,训练误差是模型$Y = \hat{f}(X)$关于训练数据集的平均损失: $$R_{emp}(\hat{f}) = \frac{1}{N}\sum_{i=1}^NL(y_i,\hat{f}(x_i))$$ 其中$N$是训练样本容量. 测试误差是模型$Y = \hat{f}(X)$关于测">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">模型评估与模型选择</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>机器学习算法 原理、实现与实战&mdash;&mdash;模型评估与模型选择</h1>
<h1>1. 训练误差与测试误差</h1>
<p>机器学习的目的是使学习到的模型不仅对已知数据而且对未知数据都能有很好的预测能力。</p>
<p>假设学习到的模型是$Y = \hat{f}(X)$，训练误差是模型$Y = \hat{f}(X)$关于训练数据集的平均损失：</p>
<p>$$R_{emp}(\hat{f}) = \frac{1}{N}\sum_{i=1}^NL(y_i,\hat{f}(x_i))$$</p>
<p>其中$N$是训练样本容量。</p>
<p>测试误差是模型$Y = \hat{f}(X)$关于测试数据集的平均损失：</p>
<p>$$e_{test}(\hat{f}) = \frac{1}{N&rsquo;}\sum_{i=1}^NL(y_i,\hat{f}(x_i))$$</p>
<p>其中$N&rsquo;$是测试样本容量。</p>
<p>当损失函数是0-1损失时，测试误差就变成了常见的测试数据集上的误差率（预测错误的个数除以测试数据的总个数）。</p>
<p>训练误差的大小，对判定给定问题是不是一个容易学习的问题是有意义的，但本质上不重要。测试误差反映了学习方法对未知数据集的预测能力，是学习中的重要概念。显然，给定两种学习方法，测试误差小的方法具有更好的预测能力，是更有效的方法。通常将学习方法对未知数据的预测能力称为<strong>泛化能力</strong>（generalization ability）。</p>
<h1>2. 过拟合与模型选择</h1>
<p>我们知道假设空间理论上有无限个模型，它们有着不同的复杂度（一般表现为参数个数的多少），我们希望选择或学习一个合适的模型。</p>
<p>如果一味提高对训练数据的预测能力，所选的模型的复杂度则往往会比真实模型更高。这种现象称为<strong>过拟合</strong>。过拟合是指学习时选择的模型所包含的参数过多，以致于出现这一模型对已知数据预测很好，但对未知数据预测很差的现象。</p>
<p>下面，以多项式函数拟合问题为例，说明过拟合与模型选择，这是一个回归问题。</p>
<p>现在给定一个训练数据集：</p>
<p>$$T=\{(x_1,y_1),(x_2,y_2),\dots,(x_n,y_n)\}$$</p>
<p>其中，$x_i\in R$是输入$x$的观测值，$y_i\in R$是相应的输出$y$的观测值。多项式函数拟合的任务是假设给定数据由M次多项式函数生成，选择最有可能产生这些数据的M次多项式函数，即在M次多项式函数中选择一个对已知数据以及未知数据都有很多预测能力的函数。</p>
<p>我们用$y = sin(x)$生成10个数据点，并适当的在$y$值上加了一些误差，下面我们分别用0~9次多项式对数据进行拟合。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzM3ODkyMC8yMDE0MTAvMzEwOTUzMDQ4MDA4OTE1LnBuZw==.jpg" />&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzM3ODkyMC8yMDE0MTAvMzEwOTUzMDkxNTkyMTgzLnBuZw==.jpg" />&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzM3ODkyMC8yMDE0MTAvMzEwOTUzMTA5NzIzNTk3LnBuZw==.jpg" /></p>
<p>上图给出了$M=1,M=3,M=9$时多项式拟合的情况。当$M=1$时多项式曲线是一条直线，数据拟合效果很差。相反，如果$M=9$，多项式曲线通过每个数据点，训练误差为0。从对给定的训练数据拟合的角度来说，效果是最好的。但是因为训练数据本身存在噪声，这种拟合曲线对未知数据的预测能力往往并不是最好的，这时过拟合现象就会发生。</p>
<pre>import numpy as np
import matplotlib.pyplot as plt
import random
x = np.linspace(0,1,10)
y = np.sin(2*np.pi*x)
for i in range(0,10):
        y[i] = y[i] + random.uniform(-0.4,0.4)
p = np.polyfit(x,y,9)
t = np.linspace(0,1.0,100)
plt.plot(x,y,‘o‘)
plt.plot(t,np.sin(np.pi*2*t),label=‘$y=sin(x)$‘);
plt.plot(t,np.polyval(p,t),label=‘$y = \sum_{i=0}^Mw_ix_i,M=9,x_0=0$‘);
plt.legend()
plt.show()</pre>

<h1>3. 正则化与交叉验证</h1>
<h2>3.1 正则化</h2>
<p>前面文章在介绍机器学习策略的时候，已经提到过结构风险最小化的概念。结构风险最小化正是为了解决过拟合问题来提出来的策略，它在经验风险上加一个正则化项。正则化项一般是模型复杂度的单调递增函数，模型越复杂，正则化值就越大。比如，正则化项可以是模型参数的向量的范数。</p>
<p>正则化项可以取不同的形式。例如，回归问题中，损失函数是平方损失，正则化项可以是参数向量的$L_2$范数：</p>
<p>$$L(w) = \frac{1}{N}\sum_{i=1}^N(f(x_i;w)-y_i)^2+\frac{\lambda}{2}||w||^2$$</p>
<p>这里，$||w||$表示参数向量$w$的$L_2$范数。</p>
<p>正则化项也可以是参数向量的$L_1$范数：</p>
<p>$$L(w) = \frac{1}{N}\sum_{i=1}^N(f(x_i;w)-y_i)^2+\lambda||w||_1$$</p>
<p>这里，$||w||_1$表示参数向量$w$的$L_1$范数。</p>
<p>正则化符合奥卡姆剃刀（Occam&rsquo;s razor）原理。奥卡姆剃刀应用在模型选择时想法是：在所有可能选择的模型中，能够很好地解释已知数据并且十分简单才是最好的模型，也就是应该选择的模型。从贝叶斯估计的角度来看，正则化项对应于模型的先验概率。可以假设复杂模型有较小的先验概率，简单的模型有较大的先验概率。</p>
<h2>3.2 交叉验证</h2>
<p>如果给定的样本数据充足，进行模型选择的一种简单方法是随机地将数据集切分成三部分，分别为训练集、验证集和测试集。训练集用来训练模型，验证集用于模型的选择，而测试集用于最终对学习方法的评估。在学习到的不同复杂度的模型中，选择对验证集有最小预测误差的模型。</p>
<p>但是在许多实际应用中数据是不充分的。为了选择好的模型，可以采用交叉验证方法。交叉验证的基本想法是重复地使用数据；把给定的数据进行切分，将切分的数据集组合为训练集与测试集，在此基础上反复地进行训练、测试以及模型选择。</p>
<h3>1. 简单交叉验证</h3>
<p>首先随机地将已给数据分为两部分，一部分作为训练集，另一部分作为测试集；然后用训练集在各种条件下训练模型，从而得到不同的模型；在测试集上评价各个模型的测试误差，选出测试误差最小的模型。</p>
<h3>2. S折交叉验证</h3>
<p>这种方法应用最多。首先随机地将已给的数据切分为S个互不相交的大小相同的子集；然后利用其中的S-1个子集的数据训练模型，然后用余下的子集测试模型；将这一过程对可能的S种选择重复进行；最后选出S次评测中平均测试误差最小的模型。</p>
<h3>3. 留一交叉验证</h3>
<p>S折交叉验证的特征情形是$S=N$，称为留一交叉验证，往往在数据缺乏的情况下使用。这里，N是给定数据集的容量。</p>
<h1>4. 泛化能力</h1>
<p>学习方法的泛化能力是指由该方法学习到的模型对未知数据的预测能力，是学习方法本质上重要的性质。现实中采用最多的办法是通过测试数据集的误差来评价学习方法的泛化能力。但是因为数据是有限的，并不能代表全体未知样本，所以很有可能按照这样评价到得的结果是不可靠的。</p>
<p>下面我们从理论上对学习方法的泛化能力进行分析。</p>
<p>首先给出泛化误差的定义。如果学习到的模型是$\hat{f}$，那么用这个模型对未知数据预测的误差即为泛化误差（generalization error）</p>
<p>$$R_{exp}(\hat{f}) = E_P[L(Y,\hat{f}(X))] = \int_{\mathcal{X}\times\mathcal{Y}}L(y,\hat{f}(x))P(x,y)dxdy$$</p>
<p>泛化误差反映了学习方法的泛化能力，如果一种方法学习的模型比另一种方法学习的模型具有更小的泛化误差，那么这种方法就更有效。事实上，泛化误差就是所学习到的模型的期望风险。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-01-31 05:25:08 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/for/" title="for">for</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>模型评估与模型选择的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e6r5v3.html" rel="bookmark">机器学习之模型评估与模型选择&lpar;学习笔记&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				时间:2014.06.26 地点:基地 -------------------------------------------------------------------------------------- 一.训练误差和测试误差 机器学习或者说统计学习的目的就是使学习到的模型不仅对已知数据而且对未知数据都都很好的预测能力.不同的学习方法会得出不同的模型.在评判学习方法的好坏时,常用的是: 1.基于损失函数的模型的训练误差                          2.模型的测试误			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBB8mqM.html" rel="bookmark">模型评估：模型状态评估</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				模型状态 过拟合和欠拟合 过拟合:在训练集上的准确率较高,而在测试集上的准确率较低 欠拟合:在训练集和测试集上的准确率均较低 学习曲线(Learning Curves) 1)概念概述 学习曲线就是通过画出不同训练集大小时训练集和交叉验证的准确率,可以看到模型在新数据上的表现,进而来判断模型是否方差偏高或偏差过高,以及增大训练集是否可以减小过拟合. 先明确两个概念: 偏差:指的是分类器对训练集和测试集的准确率与基准分类器的准确率有比较大的差距,是分类器与其他分类器的比较 方差:指的是分类器对训练集			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KAnD94.html" rel="bookmark">模型的性能评估&lpar;二&rpar;  用sklearn进行模型评估</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在sklearn当中,可以在三个地方进行模型的评估 1:各个模型的均有提供的score方法来进行评估. 这种方法对于每一种学习器来说都是根据学习器本身的特点定制的,不可改变,这种方法比较简单.这种方法受模型的影响, 2:用交叉验证cross_val_score,或者参数调试GridSearchCV,它们都依赖scoring参数传入一个性能度量函数.这种方法就是我们下面讨论的使用scoring进行模型的性能评估. 3:Metric方法,Metric有为各种问题提供的评估方法.这些问题包括分类.聚类			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qQDEW3.html" rel="bookmark">隐马尔可夫模型模型评估及最优路径的matlab实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				自己根据算法编写了两个简单的matlab代码,应用于例子中的数据取得了正确的解,这里并没有考虑速度优化的问题,请大家不吝指教: 1.模型评估 HMM模型如下,试根据前向算法计算产生观察符号序列O={ABAB}的概率. 状态转移概率矩阵 a = [0.4 0.6 0 ; 0   0.8 0.2; 0   0    1 ]; 观测矩阵: o= [0.7 0.3 0.7 0.3; 0.4 0.6 0.4 0.6; 0.8 0.2 0.8 0.2]; 初始概率矩阵: pi = [1 0 0]; 例题中的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/M6zVKGM.html" rel="bookmark">机器学习笔记&lpar;二&rpar;模型评估与选择</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.模型评估与选择 2.1经验误差和过拟合 不同学习算法及其不同参数产生的不同模型,涉及到模型选择的问题,关系到两个指标性,就是经验误差和过拟合. 1)经验误差 错误率(errorrate):分类错误的样本数占样本总数的比例.如果在m个样本中有a个样本分类错误,则错误率E=a/m,相应的,1-a/m称为精度(accuracy),即精度=1-错误率. 误差(error):学习器的实际预测输出和样本的真实输出之间的差异.训练误差或经验误差:学习器在训练集上的误差:泛化误差:学习器在新样本上的误差.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02XlGa4.html" rel="bookmark">【机器学习 第2章 学习笔记】模型评估与选择</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.训练误差:学习器在训练集上的误差,也称“经验误差” 2.泛化误差:学习器在新样本上的误差 显然,我们的目标是得到在新样本上表现更好的学习器,即泛化误差要小 3.过拟合:学习器把训练样本学的太好了,导致泛化性能下降(学过头了...让我联想到有些人死读书,读死书,僵化,不懂得变通和举一反三) 原因:学习能力过于强大,把一些不太一般的特性也学了进来 针对措施:不好解决,是机器学习面临的关键障碍 4.欠拟合:就是连训练集都没学好,更别说泛化了(有点管中窥豹,盲人摸象的意思). 原因: 学习能力低下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzYZYl4.html" rel="bookmark">机器学习总结之第二章模型评估与选择</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				机器学习总结之第二章模型评估与选择 2.1经验误差与过拟合 错误率 = a个样本分类错误/m个样本 精度 = 1 - 错误率 误差:学习器实际预测输出与样本的真是输出之间的差异. 训练误差:即经验误差.学习器在训练集上的误差. 泛化误差:学习器在新样本上的误差. 过拟合:学习器把训练样本学的&quot;太好&quot;,把不太一般的特性学到了,泛化能力下降,对新样本的判别能力差.必然存在,无法彻底避免,只能够减小过拟合风险. 欠拟合:对训练样本的一半性质尚未学好. 2.2评估方法 (在现实任务中,还需考虑			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3O6Byr0.html" rel="bookmark">【机器学习123】模型评估与选择 &lpar;上&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第2章 模型评估与选择 2.1 经验误差与过拟合 先引出几个基本概念: 误差(error):学习器的实际预测输出与样本的真实输出之间的差异. 训练误差(training error):学习器在训练集上的误差,也称&quot;经验误差&quot;. 测试误差(testing error):学习器在测试集上的误差. 泛化误差(generalization error):学习器在新样本上的误差. 错误率(error rate):分类错误的样本数占样本总数的比例. 精度(accuracy) = 1 – 错误率.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35Q11E3.html" rel="bookmark">第二章 模型评估与选择</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				2.1  经验误差与过拟合 错误率和精度:通常我们把分类错误的样本占样本总数的比例称为“错误率”(error rate),即如果在m个样本中有a个样本分类错误,则错误率E=a/m:相应的,1-a/m称为“精度”.(accuracy).即“精度=1-错误率”. 误差:学习期的实际预测误差和样本的真实输出之间的差异称为“误差”(error) 训练误差/经验误差:学习器在训练集上的误差称为“训练误差”(training error)或 “经验误差”(expircial error) 泛化误差(gene			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/r0aQqn0.html" rel="bookmark" class="title">mkfs命令说明</a>
					<div>
						Description mkfs.xfs constructs an XFS filesystem by writing on a special file using the values foun ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35Xao0.html" rel="bookmark" class="title">fedora安装chrome报错</a>
					<div>
						安装chrome的rpm的时候,提示如下信息 警告:google-chrome-stable_current_x86_64.rpm: 头V4 DSA/SHA1 Signature, 密钥 ID 7fa ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/j35ZnR4.html" rel="bookmark" class="title">bzoj3670&lbrack;Noi2014&rsqb;动物园</a>
					<div>
						bzoj3670[Noi2014]动物园 题意: 对于字符串S的前i个字符构成的子串,既是它的后缀同时又是它的前缀,并且该后缀与该前缀不重叠,将这种字符串的数量记作num[i].给出字符串S求所有nu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M68Rbr3.html" rel="bookmark" class="title">asp&period;net反射应用</a>
					<div>
						反射的应用为了解藕程序,让程序日后的维护和二次开发时动用的代码部分很少. 要用到的命名空间using reflection 1.在程序运行时,(动态获取类或对象的信息) 动态 获取 加载程序集(Ass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0n1QkVM.html" rel="bookmark" class="title">HDU 3008  Warcraft</a>
					<div>
						题意:一个人有100点血和100点魔法,Boss有100点血,人有n个技能,每个技能对Boss有a[i]点伤害, 且会消耗b[i] 的点魔量,人每秒会有t秒魔法恢复(最大为100)Boss每秒有q点伤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35bKR14.html" rel="bookmark" class="title">python 学习day5</a>
					<div>
						1.字符串格式化 百分号格式化 s = &quot; i am %s&quot; % 'wyx'    #通过位置传递参数 ,格式化字符串类型   s = 'i am %(name)s' % {'na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41812X3.html" rel="bookmark" class="title">centos和redhat vsftp安装和设定</a>
					<div>
						1.安装vsftp yum install vsftpd 2.配置vsftp 配置文件在 /etc/vsftpd/vsftpd.conf,建议把匿名登录关闭 anonymous_enable=NO 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35qAg13.html" rel="bookmark" class="title">HDU 5881 Tea &lpar;模拟&rpar;</a>
					<div>
						题意:有一壶水, 体积在 LLL 和 RRR 之间, 有两个杯子, 你要把水倒到两个杯子里面, 使得杯子水体积几乎相同(体积的差值小于等于1), 并且使得壶里剩下水体积不大于1. 你无法测量壶里剩下水 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MglgbL0.html" rel="bookmark" class="title">C&plus;&plus; Primer 第四版课后练习解答 习题1&period;18</a>
					<div>
						注意:本随笔是直接参考&lt;C++Primer(第四版)习题解答(完整版)&gt;中的.此处主要是便于本人以后反复阅读. 习题1.18 编写程序,提示用户输入两个数并将这两个数范围内的每个数写到标准 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdnQb0.html" rel="bookmark" class="title">Mac下命令行打开Sublime</a>
					<div>
						open -a /Applications/Sublime\ Text\ 2.app composer.json 每次这样输太麻烦,可以这样: ln -s /Applications/Sublime\ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBmdX3.html" rel="bookmark" class="title">织梦调用父级栏目链接和名称</a>
					<div>
						打开文件 /include/taglib/channel.lib.php 找到代码 else if($type=='self') { if($reid==0) return ''; $sql = &q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0klkR73.html" rel="bookmark" class="title">虚拟机的时间同步</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MynANY0.html" rel="bookmark" class="title">ElasticSearch的各种服务的URL</a>
					<div>
						1.curl 192.168.106.58:9200/_cat/health?v  集群健康查看 epoch      timestamp cluster       status node.tota ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KP9vj3.html" rel="bookmark" class="title">html标签分类以及常用标签</a>
					<div>
						WEB初级编程人员必须掌握的html标签分类以及常用标签 1. 内容简介: ·文本版面的编辑(格式标签.文本标签) ·超链接和锚点 ·图像和图像地图 2. 格式标签: 用于定义网页中文本的布局.缩进. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l9X1p3.html" rel="bookmark" class="title">typedef 与define 的区别</a>
					<div>
						typedef和#define的用法与区别 typedef和#define的用法与区别 一.typedef的用法 在C/C++语言中,typedef常用来定义一个标识符及关键字的别名,它是语言编译过程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQvmO0.html" rel="bookmark" class="title">使用下拉列表框进行多选</a>
					<div>
						下拉列表也可以进行多选操作,在&lt;select&gt;标签中设置multiple=&quot;multiple&quot;属性,就可以实现多选功能,在 widows 操作系统下,进行多选时按下Ct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jaz2AM.html" rel="bookmark" class="title">因为权限原因要在filter里使用spring- service所产生的问题</a>
					<div>
						参考: 加载顺序 http://blog.csdn.net/wayfoon322/article/details/2418011 filter 使用注入bean  http://zy116494718 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPOxVB4.html" rel="bookmark" class="title">关于html中table表格tr&comma;td的高度和宽度</a>
					<div>
						做网页的时候精到会遇到各种各样的问题,经常遇到的一个就是会碰到表格宽度对不齐的问题. 首先,来分析一下这三个标签中height和width的区别: 1.table中的width和height设置及其作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41vovOM.html" rel="bookmark" class="title">图的深度优先搜索 递归和非递归实现 c&plus;&plus;版本</a>
					<div>
						本文参考了李春葆版本的数据结构上机指导,但是原版是c代码, 本文用了c++实现,并且修复了深度优先搜索非递归的一个bug. graph.cpp文件: #include &quot;graph.h&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGLABy0.html" rel="bookmark" class="title">abp 嵌入资源（视图、css、js）的访问</a>
					<div>
						最近在做的基于abp作为框架的一个项目,将一些属于框架功能的页面写在了一个独立程序集中,然后在web项目中引用该程序集达到访问框架页面目的. 这样一来发布web之后,在发布目录中是看不到写在另一个程序 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
